VERSION 5.00
Object = "{D01BD6BE-456A-4078-AEBF-3ACB85261FA6}#2.0#0"; "VCProX.ocx"
Begin VB.Form formMain 
   Caption         =   "Wave Pass Through"
   ClientHeight    =   2190
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   2190
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VCProX.vcproWaveCodecDeviceX waveCodec 
      Height          =   495
      Left            =   120
      TabIndex        =   5
      Top             =   1560
      Width           =   1095
      Active          =   0   'False
      AutoActivate    =   -1  'True
      CalcVolume      =   0   'False
      DumpInput       =   ""
      DumpOutput      =   ""
      FormatTag       =   1
      FormatTagImmunable=   -1  'True
      InputIsPcm      =   -1  'True
      IsFormatProvider=   -1  'True
      OverNum         =   5
      PcmBitsPerSample=   16
      PcmNumChannels  =   2
      PcmSamplesPerSec=   44100
      RealTime        =   0   'False
   End
   Begin VCProX.vcproWaveRiffX waveWrite 
      Height          =   495
      Left            =   1440
      TabIndex        =   3
      Top             =   600
      Width           =   1095
      Active          =   0   'False
      AutoActivate    =   -1  'True
      CalcVolume      =   0   'False
      DumpInput       =   ""
      DumpOutput      =   ""
      IsFormatProvider=   0   'False
      OverNum         =   0
      PcmBitsPerSample=   16
      PcmNumChannels  =   2
      PcmSamplesPerSec=   44100
      FileName        =   ""
      IsInput         =   0   'False
      Loop            =   0   'False
      RealTime        =   0   'False
   End
   Begin VCProX.vcproWaveRiffX waveRead 
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   1095
      Active          =   0   'False
      AutoActivate    =   0   'False
      CalcVolume      =   0   'False
      DumpInput       =   ""
      DumpOutput      =   ""
      IsFormatProvider=   -1  'True
      OverNum         =   5
      PcmBitsPerSample=   16
      PcmNumChannels  =   2
      PcmSamplesPerSec=   44100
      FileName        =   ""
      IsInput         =   -1  'True
      Loop            =   0   'False
      RealTime        =   0   'False
   End
   Begin VB.Timer Timer1 
      Interval        =   500
      Left            =   3600
      Top             =   840
   End
   Begin VB.CommandButton button_go 
      Caption         =   "&Go"
      Height          =   375
      Left            =   3600
      TabIndex        =   1
      Top             =   120
      Width           =   975
   End
   Begin VB.TextBox edit_fileName 
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Text            =   "J:\_data\_audio\TheSun.wav"
      Top             =   120
      Width           =   3255
   End
   Begin VB.Label label_info 
      Caption         =   "Info - press Go to start"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   1200
      Width           =   2415
   End
End
Attribute VB_Name = "formMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim chunk_count, sleep_wait

Private Sub SetLink(provider As VCProX.IvcproProvider, consumer As VCProX.IvcproConsumer)
    provider.AddConsumer consumer
End Sub

Private Sub button_go_Click()
    '
    waveRead.FileName = edit_fileName.Text
    chunk_count = 0
    sleep_wait = 5
    '
    waveRead.Active = True
    '
End Sub

Private Sub Form_Load()
    SetLink waveRead.object, waveCodec.object
End Sub

Private Sub Form_Unload(Cancel As Integer)
    waveRead.Active = False
    waveWrite.Active = False
End Sub

Private Sub Timer1_Timer()
    '
    label_info.Caption = waveCodec.PcmSamplesPerSec & "Hz; " & waveCodec.PcmBitsPerSample & " bits; " & waveCodec.PcmNumChannels & " channel(s)"
    '
    If (Not waveRead.Active And waveWrite.Active) Then
        If (1 > sleep_wait) Then
            waveWrite.Flush
            waveWrite.Active = False
        Else
            sleep_wait = sleep_wait - 1
        End If
    End If
    '
End Sub

Private Sub waveRead_OnDataAvailable()
    '
    If (Not waveWrite.Active) Then
        '
        waveWrite.PcmSamplesPerSec = waveCodec.PcmSamplesPerSec
        waveWrite.PcmBitsPerSample = waveCodec.PcmBitsPerSample
        waveWrite.PcmNumChannels = waveCodec.PcmNumChannels
        waveWrite.FileName = waveRead.FileName & ".wt.wav"
        '
        waveWrite.Active = True
    End If
    '
    If (0 = chunk_count) Then
        Dim data As Variant
        Dim size As Integer
            
        data = waveRead.GetData
        size = Len(data)

        ' since chunk has 20 ms of audio,
        ' and we need only first 5 ms, we can fill the rest with silence
        For i = size / 4 To size - 1
            data(i) = 0
        Next i

        ' also, if we want to copy some data to our array, we can do that as following:
        '
        ' For i = size / 4 To size - 1
        '    data(i) = data_other(j)
        ' Next i
        
        ' now we can save the data into file
        waveWrite.SetData data
        
        ' interested in first chunk only
        chunk_count = 1
    End If
End Sub
